#include <stdio.h>
#include <stdlib.h>

long expomod( long a, long n, long z );

main()
{
   long a, n, z;

   printf( "enter a, n, z (computes a^n mod z): " );
   scanf( "%ld%ld%ld", &a, &n, &z );
   printf( "a^n mod z = %ld\n", expomod( a, n, z ) );

   return EXIT_SUCCESS;
}

long expomod( long a, long n, long z )
{
   long r, x;

   r = 1;
   x = a % z;
   while ( n > 0 ) {
      if ( n % 2 ) /* if i is odd */
         r = ( r * x ) % z;
      x = ( x * x ) % z;
      n /= 2;
   }

   return r;
}